import React, { Component } from "react";
import { connect } from "react-redux";
// import { reduxForm, Field } from "redux-form";
import "./adminMyEventsPage.scss";
import * as actions from "../../actions/adminMainPageActions";
import AdminHeader from "../../components/adminHeader/adminHeader";
import Form from "../../components/eventForm/eventReduxForm";
// import AdminEventElement from "../../components/adminEventElement/adminEventElement";
import ConfirmationMessage from "../../components/confirmationMessage/confirmationMessage";
// import {customSelect} from "../../components/customFields/customSelect/customSelect";
import EventInfoShort from "../../components/eventInfoShort/EventInfoShort";

class AdminAddEventPage extends Component {

    state = {
        confirmationMessageFlag: false,
        // initialValues: this.props.eventFormInitialValue,
        // eventList: this.props.eventList,
        showFormFlag: false
    };


    componentDidMount() {
        this.props.getEvents();
    }

    // resetInitValue = () => this.setState({ eventFormInitialValue: {} });

    // showConfirmationMessage = () => this.setState({confirmationMessageFlag: true });
    // closeConfirmationMessage = () => this.setState({confirmationMessageFlag: false });


    // editItem = item =>
    // this.setState(prevState => ({
    //     ...prevState,
    //     showFormFlag: true,
    //     eventList: prevState.eventList.map(el => (el.id === item.id ? item : el))
    // }));

    // setInitialValues = id =>
    // this.setState(prevState => {
    //     console.log('prevState', prevState)
    //     return {
    //     ...prevState,
    //     eventFormInitialValue: prevState.eventList.find(el => el._id === id)
    // }});

    render() {
        const {
            postNewEvent,
            eventList,
            // eventFormInitialValue,
            // eventTypes
        } = this.props

        console.log('eventList', eventList)
        // console.log('confirmationMessageFlag', this.state.confirmationMessageFlag)

        // console.log("eventFormInitialValue", eventFormInitialValue);
        return (
            <>
                <AdminHeader />
                <div className="event-page">
                    <div className="event-page__content">
                        <h2 className="event-page__title">MY EVENTS</h2>

                        <div className="event-page__container">
                            {eventList && eventList.map(el =>
                                <div key={el._id}>
                                    <EventInfoShort
                                        key={el._id}
                                        title={el.title}
                                        country={el.country}
                                        city={el.city}
                                        id={el._id}
                                        eventDate={el.eventDate}
                                        imgSrc={el.mainBannerPicture}
                                    />
                                    <div className="event-buttons-conteiner">
                                        <button className="event-button" >Edit Event</button>
                                        <button className="event-button" >Delete Event</button>
                                    </div>
                                </div>
                                // <AdminEventElement
                                //     key={elem._id}
                                //     img={elem.mainBannerPicture}
                                //     title={elem.title}
                                //     id={elem._id}
                                //     // onClick={showCarElement.bind(null, elem.id)}
                                // />
                            )}
                        </div>

                        {this.showFormFlag && <Form
                            initialValues={this.state.initialValues}
                            postNewEvent={postNewEvent}
                            editItem={this.editItem}
                            resetInitValue={this.resetInitValue}
                            showConfirmationMessage={this.showConfirmationMessage}
                        />}
                    </div>
                </div>

                {this.state.confirmationMessageFlag &&
                    <ConfirmationMessage closeMessage={this.closeConfirmationMessage}>
                        <div className="text">Event has beed changed.</div>
                    </ConfirmationMessage >}
            </>
        );
    }
}

const mapStateToProps = state => ({
    eventList: state.adminMainPageReducer.eventList,
    eventFormInitialValue: state.adminMainPageReducer.eventFormInitialValue,
    eventTypes: state.adminMainPageReducer.eventTypes,
});

export default connect(mapStateToProps, actions)(AdminAddEventPage);